' DeviceNames.vbs
'
' Searches for all USB Debug Adapters and lists the names of the
' devices connected to them.
'
' Remember to add the path to USBHID.dll to %PATH% or copy the file
' to your System32 directory.
Option Explicit

const JTAG = 0
const C2 = 1

Dim oUtil
Dim NumDevices
Dim DevNum
Dim DeviceNames

Set oUtil = CreateObject("SiUtilEx.SiUtilExUSB")
oUtil.DisableDialogBoxes = True
NumDevices = oUtil.DebugDevices

For DevNum = 0 To NumDevices - 1
  On Error Resume Next
  DeviceNames = DeviceNames & oUtil.GetDeviceSN(DevNum) & ": "

  ' Connect-Method will connect to the Debug-Adapter with the serial number selected in the next line
  oUtil.SerialNumber = oUtil.GetDeviceSN(DevNum)
  Err.Number = 0
  oUtil.Connect JTAG ' Try connecting through JTAG interface

  If Err.Number = 0 Then
     DeviceNames = DeviceNames & oUtil.GetDeviceName
  Else
    ' The Debugger remains occupied on failure of Connect
    ' This second call releases the connection (Disconnect in this special case)
    oUtil.Connect JTAG

    Err.Number = 0
    oUtil.Connect C2   ' Try connecting through C2 interface
    If Err.Number = 0 Then
      DeviceNames = DeviceNames & oUtil.GetDeviceName
    Else
      DeviceNames = DeviceNames & Err.Description
    End If
  End If

  DeviceNames = DeviceNames & vbCrLf
  oUtil.Disconnect
Next

WScript.Echo DeviceNames
