#ifndef CSIUTILEX_H
#define CSIUTILEX_H

class CSiUtilEx : public ISiUtilEx, public IProvideClassInfo, public ISupportErrorInfo
{
protected:
    inline IUnknown* GetUnknown() { return(static_cast<ISiUtilEx*>(this)); }

public:
    // IUnknown
    IFACEMETHOD(QueryInterface) (REFIID riid, void** ppvObject);
    IFACEMETHOD_(ULONG, AddRef) ();
    IFACEMETHOD_(ULONG, Release)();

    // IDispatch
    IFACEMETHOD(GetTypeInfoCount)(UINT* pctinfo);
    IFACEMETHOD(GetTypeInfo)(UINT iTInfo, LCID lcid, ITypeInfo** ppTInfo);
    IFACEMETHOD(GetIDsOfNames)(REFIID riid, LPOLESTR* rgszNames, UINT cNames, LCID lcid, DISPID* rgDispId);
    IFACEMETHOD(Invoke)(DISPID dispIdMember, REFIID riid, LCID lcid, WORD wFlags, DISPPARAMS* pDispParams, VARIANT* pVarResult, EXCEPINFO* pExcepInfo, UINT* puArgErr);

    // ISiUtilEx
    IFACEMETHOD(get_CommPort)(long* plCommPort);
    IFACEMETHOD(put_CommPort)(long lCommPort);
    IFACEMETHOD(get_DisableDialogBoxes)(VARIANT_BOOL* pblDisable);
    IFACEMETHOD(put_DisableDialogBoxes)(VARIANT_BOOL blDisable);
    IFACEMETHOD(get_Version)(BSTR* pbstrVersion);
    IFACEMETHOD(Connect)(enum ECprotocol proto, enum BaudRateIndex baud);
    IFACEMETHOD(Disconnect)();
    IFACEMETHOD(Connected)(VARIANT_BOOL* pblConnected);
    IFACEMETHOD(SetTargetGo)();
    IFACEMETHOD(SetTargetHalt)();
    IFACEMETHOD(ISupportBanking)(long* pnSupportedBanks);
    IFACEMETHOD(Download)(BSTR sDownloadFile, VARIANT_BOOL blDeviceErase, VARIANT_BOOL blDownloadScratchPadSFLE, long nBankSelect, VARIANT_BOOL blLockFlash, VARIANT_BOOL blPersistFlash, long* usChecksum);
    IFACEMETHOD(TargetReset)();
    IFACEMETHOD(GetRAMMemory)(long nStartAddress, long nLength, SAFEARRAY** ppMem);
    IFACEMETHOD(GetXRAMMemory)(long nStartAddress, long nLength, SAFEARRAY** ppMem);
    IFACEMETHOD(GetCodeMemory)(long nStartAddress, long nLength, SAFEARRAY** ppMem);
    IFACEMETHOD(SetRAMMemory)(long nStartAddress, SAFEARRAY** ppMem);
    IFACEMETHOD(SetXRAMMemory)(long nStartAddress, SAFEARRAY** ppMem);
    IFACEMETHOD(SetCodeMemory)(long nStartAddress, SAFEARRAY** ppMem);
    IFACEMETHOD(FLASHErase)(enum ECprotocol proto);
    IFACEMETHOD(GetSAFirmwareVersion)(long* pnVersion);
    IFACEMETHOD(SetJTAGDeviceAndConnect)(long nDevicesBeforeTarget, long nDevicesAfterTarget, long IRBitsBeforeTarget, long IRBitsAfterTarget);
    IFACEMETHOD(GetDeviceName)(BSTR* psDeviceName);
    IFACEMETHOD(SetAppName)(BSTR AppName);
    IFACEMETHOD(GetScratchPadMemory)(long nStartAddress, long nLength, SAFEARRAY** ppMem);
    IFACEMETHOD(SetScratchPadMemory)(long nStartAddress, SAFEARRAY** ppMem);
    IFACEMETHOD(VerifyFlashDownload)(BSTR sDownloadFile, long nBankSelect, VARIANT_BOOL* pblSuccess);
    IFACEMETHOD(DownloadTxt)(BSTR sDownloadFile, long nStartAddress, VARIANT_BOOL blDeviceErase, VARIANT_BOOL blLockFlash, VARIANT_BOOL blPersistFlash, long* usChecksum);
    IFACEMETHOD(GetDeviceRevision)(long* pPartRev);

    //IProvideClassInfo
    IFACEMETHOD(GetClassInfo)(ITypeInfo** ppTI);

    //SupportErrorInfo
    IFACEMETHOD(InterfaceSupportsErrorInfo)(REFIID riid);

    explicit CSiUtilEx(HRESULT* phr);
    virtual ~CSiUtilEx();

private:
    inline HRESULT RaiseCOMException(DISPID dispid, HRESULT hr) { return(::RaiseCOMException(this, dispid, hr)); }

    ITypeInfo*      m_pTypeInfo;
    volatile long   m_lCommPort;
    volatile long   m_nDisableDialogBoxes;
    volatile ULONG  m_lRefCount;
#ifdef _WIN64
    BYTE bPadding[4]; // C4820
#endif
};

#endif
