// mailto:renkoe@tbkoenig.de

#ifndef SIUTILEX_H
#define SIUTILEX_H

// {19EB2E45-15EB-4D3B-A9DF-D2FE4D13ECD6}
DEFINE_GUID(CLSID_SiUtilEx,
    0x19EB2E45, 0x15EB, 0x4D3B, 0xA9, 0xDF, 0xD2, 0xFE, 0x4D, 0x13, 0xEC, 0xD6);

// {C93471CF-43C1-4BE5-A997-CFB1DDBCBFDA}
DEFINE_GUID(IID_ISiUtilEx,
    0xC93471CF, 0x43C1, 0x4BE5, 0xA9, 0x97, 0xCF, 0xB1, 0xDD, 0xBC, 0xBF, 0xDA);

// {23C1FC6F-B4C0-4BB5-B66B-7ABA49A12923}
DEFINE_GUID(CLSID_SiUtilExUSB,
    0x23C1FC6F, 0xB4C0, 0x4BB5, 0xB6, 0x6B, 0x7A, 0xBA, 0x49, 0xA1, 0x29, 0x23);

// {8D54E100-3741-49BD-8F37-2BD35AFA8FDB}
DEFINE_GUID(IID_ISiUtilExUSB,
    0x8D54E100, 0x3741, 0x49BD, 0x8F, 0x37, 0x2B, 0xD3, 0x5A, 0xFA, 0x8F, 0xDB);

// {FC7C15A5-164C-4C5D-9AD3-92F224BB36B8}
DEFINE_GUID(LIBID_SiUtilExLib,
    0xFC7C15A5, 0x164C, 0x4C5D, 0x9A, 0xD3, 0x92, 0xF2, 0x24, 0xBB, 0x36, 0xB8);

enum ECprotocol
{
    JTAG = 0,
    C2 = 1
};

enum BaudRateIndex
{
    AutoBaud = 0,
    Baud_115200 = 1,
    Baud_57600 = 2,
    Baud_38400 = 3,
    Baud_9600 = 4,
    Baud_2400 = 5
};

#undef  INTERFACE
#define INTERFACE ISiUtilEx
DECLARE_INTERFACE_IID_(ISiUtilEx, IDispatch, "C93471CF-43C1-4BE5-A997-CFB1DDBCBFDA")
{
    BEGIN_INTERFACE

    STDMETHOD(QueryInterface) (THIS_ REFIID riid, void** ppvObject)PURE;
    STDMETHOD_(ULONG, AddRef) (THIS)PURE;
    STDMETHOD_(ULONG, Release)(THIS)PURE;

    STDMETHOD(GetTypeInfoCount)(THIS_ UINT* pctinfo)PURE;
    STDMETHOD(GetTypeInfo)(THIS_ UINT iTInfo, LCID lcid, ITypeInfo** ppTInfo)PURE;
    STDMETHOD(GetIDsOfNames)(THIS_ REFIID riid, LPOLESTR* rgszNames, UINT cNames, LCID lcid, DISPID* rgDispId)PURE;
    STDMETHOD(Invoke)(THIS_ DISPID dispIdMember, REFIID riid, LCID lcid, WORD wFlags, DISPPARAMS* pDispParams, VARIANT* pVarResult, EXCEPINFO* pExcepInfo, UINT* puArgErr)PURE;

    STDMETHOD(get_CommPort)(THIS_ long* plCommPort)PURE;
    STDMETHOD(put_CommPort)(THIS_ long lCommPort)PURE;
    STDMETHOD(get_DisableDialogBoxes)(THIS_ VARIANT_BOOL* pblDisable)PURE;
    STDMETHOD(put_DisableDialogBoxes)(THIS_ VARIANT_BOOL blDisable)PURE;
    STDMETHOD(get_Version)(THIS_ BSTR* pbstrVersion)PURE;
    STDMETHOD(Connect)(THIS_ enum ECprotocol proto, enum BaudRateIndex baud)PURE;
    STDMETHOD(Disconnect)(THIS)PURE;
    STDMETHOD(Connected)(THIS_ VARIANT_BOOL* pblConnected)PURE;
    STDMETHOD(SetTargetGo)(THIS)PURE;
    STDMETHOD(SetTargetHalt)(THIS)PURE;
    STDMETHOD(ISupportBanking)(THIS_ long* pnSupportedBanks)PURE;
    STDMETHOD(Download)(THIS_ BSTR sDownloadFile, VARIANT_BOOL blDeviceErase, VARIANT_BOOL blDownloadScratchPadSFLE, long nBankSelect, VARIANT_BOOL blLockFlash, VARIANT_BOOL blPersistFlash, long* usChecksum)PURE;
    STDMETHOD(TargetReset)(THIS)PURE;
    STDMETHOD(GetRAMMemory)(THIS_ long nStartAddress, long nLength, SAFEARRAY** ppMem)PURE;
    STDMETHOD(GetXRAMMemory)(THIS_ long nStartAddress, long nLength, SAFEARRAY** ppMem)PURE;
    STDMETHOD(GetCodeMemory)(THIS_ long nStartAddress, long nLength, SAFEARRAY** ppMem)PURE;
    STDMETHOD(SetRAMMemory)(THIS_ long nStartAddress, SAFEARRAY** ppMem)PURE;
    STDMETHOD(SetXRAMMemory)(THIS_ long nStartAddress, SAFEARRAY** ppMem)PURE;
    STDMETHOD(SetCodeMemory)(THIS_ long nStartAddress, SAFEARRAY** ppMem)PURE;
    STDMETHOD(FLASHErase)(THIS_ enum ECprotocol proto)PURE;
    STDMETHOD(GetSAFirmwareVersion)(THIS_ long* pnVersion)PURE;
    STDMETHOD(SetJTAGDeviceAndConnect)(THIS_ long nDevicesBeforeTarget, long nDevicesAfterTarget, long IRBitsBeforeTarget, long IRBitsAfterTarget)PURE;
    STDMETHOD(GetDeviceName)(THIS_ BSTR* psDeviceName)PURE;
    STDMETHOD(SetAppName)(THIS_ BSTR AppName)PURE;
    STDMETHOD(GetScratchPadMemory)(THIS_ long nStartAddress, long nLength, SAFEARRAY** ppMem)PURE;
    STDMETHOD(SetScratchPadMemory)(THIS_ long nStartAddress, SAFEARRAY** ppMem)PURE;
    STDMETHOD(VerifyFlashDownload)(THIS_ BSTR sDownloadFile, long nBankSelect, VARIANT_BOOL* pblSuccess)PURE;
    STDMETHOD(DownloadTxt)(THIS_ BSTR sDownloadFile, long nStartAddress, VARIANT_BOOL blDeviceErase, VARIANT_BOOL blLockFlash, VARIANT_BOOL blPersistFlash, long* usChecksum)PURE;
    STDMETHOD(GetDeviceRevision)(THIS_ long* pPartRev)PURE;

    END_INTERFACE
};

#undef  INTERFACE
#define INTERFACE ISiUtilExUSB
DECLARE_INTERFACE_IID_(ISiUtilExUSB, IDispatch, "8D54E100-3741-49BD-8F37-2BD35AFA8FDB")
{
    BEGIN_INTERFACE

    STDMETHOD(QueryInterface) (THIS_ REFIID riid, void** ppvObject)PURE;
    STDMETHOD_(ULONG, AddRef) (THIS)PURE;
    STDMETHOD_(ULONG, Release)(THIS)PURE;

    STDMETHOD(GetTypeInfoCount)(THIS_ UINT* pctinfo)PURE;
    STDMETHOD(GetTypeInfo)(THIS_ UINT iTInfo, LCID lcid, ITypeInfo** ppTInfo)PURE;
    STDMETHOD(GetIDsOfNames)(THIS_ REFIID riid, LPOLESTR* rgszNames, UINT cNames, LCID lcid, DISPID* rgDispId)PURE;
    STDMETHOD(Invoke)(THIS_ DISPID dispIdMember, REFIID riid, LCID lcid, WORD wFlags, DISPPARAMS* pDispParams, VARIANT* pVarResult, EXCEPINFO* pExcepInfo, UINT* puArgErr)PURE;

    STDMETHOD(get_SerialNumber)(THIS_ BSTR* sSerialNum)PURE;
    STDMETHOD(put_SerialNumber)(THIS_ BSTR sSerialNum)PURE;
    STDMETHOD(get_DisableDialogBoxes)(THIS_ VARIANT_BOOL* pblDisable)PURE;
    STDMETHOD(put_DisableDialogBoxes)(THIS_ VARIANT_BOOL blDisable)PURE;
    STDMETHOD(get_Version)(THIS_ BSTR* pbstrVersion)PURE;
    STDMETHOD(Connect)(THIS_ enum ECprotocol proto, long nPowerTarget)PURE;
    STDMETHOD(Disconnect)(THIS)PURE;
    STDMETHOD(Connected)(THIS_ VARIANT_BOOL* pblConnected)PURE;
    STDMETHOD(SetTargetGo)(THIS)PURE;
    STDMETHOD(SetTargetHalt)(THIS)PURE;
    STDMETHOD(ISupportBanking)(THIS_ long* pnSupportedBanks)PURE;
    STDMETHOD(Download)(THIS_ BSTR sDownloadFile, VARIANT_BOOL blDeviceErase, VARIANT_BOOL blDownloadScratchPadSFLE, long nBankSelect, VARIANT_BOOL blLockFlash, VARIANT_BOOL blPersistFlash, long* usChecksum)PURE;
    STDMETHOD(TargetReset)(THIS)PURE;
    STDMETHOD(GetRAMMemory)(THIS_ long nStartAddress, long nLength, SAFEARRAY** ppMem)PURE;
    STDMETHOD(GetXRAMMemory)(THIS_ long nStartAddress, long nLength, SAFEARRAY** ppMem)PURE;
    STDMETHOD(GetCodeMemory)(THIS_ long nStartAddress, long nLength, SAFEARRAY** ppMem)PURE;
    STDMETHOD(SetRAMMemory)(THIS_ long nStartAddress, SAFEARRAY** ppMem)PURE;
    STDMETHOD(SetXRAMMemory)(THIS_ long nStartAddress, SAFEARRAY** ppMem)PURE;
    STDMETHOD(SetCodeMemory)(THIS_ long nStartAddress, SAFEARRAY** ppMem)PURE;
    STDMETHOD(FLASHErase)(THIS_ enum ECprotocol proto)PURE;
    STDMETHOD(GetFirmwareVersion)(THIS_ long* pnVersion)PURE;
    STDMETHOD(SetJTAGDeviceAndConnect)(THIS_ long nPowerTarget, long nDevicesBeforeTarget, long nDevicesAfterTarget, long IRBitsBeforeTarget, long IRBitsAfterTarget)PURE;
    STDMETHOD(DebugDevices)(THIS_ long* dwDevices)PURE;
    STDMETHOD(GetDeviceSN)(THIS_ long nDeviceNum, BSTR* psSerialNum)PURE;
    STDMETHOD(GetDeviceName)(THIS_ BSTR* psDeviceName)PURE;
    STDMETHOD(SetAppName)(THIS_ BSTR AppName)PURE;
    STDMETHOD(GetScratchPadMemory)(THIS_ long nStartAddress, long nLength, SAFEARRAY** ppMem)PURE;
    STDMETHOD(SetScratchPadMemory)(THIS_ long nStartAddress, SAFEARRAY** ppMem)PURE;
    STDMETHOD(VerifyFlashDownload)(THIS_ BSTR sDownloadFile, long nBankSelect, VARIANT_BOOL* pblSuccess)PURE;
    STDMETHOD(DownloadTxt)(THIS_ BSTR sDownloadFile, long nStartAddress, VARIANT_BOOL blDeviceErase, VARIANT_BOOL blLockFlash, VARIANT_BOOL blPersistFlash, long* usChecksum)PURE;
    STDMETHOD(GetDeviceRevision)(THIS_ long* pPartRev)PURE;

    END_INTERFACE
};

// DISPIDs
#define DISPID_SIUTILEX_COMMPORT                0x00000001
#define DISPID_SIUTILEX_DISABLEDIALOGBOXES      0x00000002
#define DISPID_SIUTILEX_VERSION                 0x00000003
#define DISPID_SIUTILEX_CONNECT                 0x00000010
#define DISPID_SIUTILEX_DISCONNECT              0x00000011
#define DISPID_SIUTILEX_CONNECTED               0x00000012
#define DISPID_SIUTILEX_SETTARGETGO             0x00000013
#define DISPID_SIUTILEX_SETTARGETHALT           0x00000014
#define DISPID_SIUTILEX_ISUPPORTBANKING         0x00000015
#define DISPID_SIUTILEX_DOWNLOAD                0x00000016
#define DISPID_SIUTILEX_TARGETRESET             0x00000017
#define DISPID_SIUTILEX_GETRAMMEMORY            0x00000018
#define DISPID_SIUTILEX_GETXRAMMEMORY           0x00000019
#define DISPID_SIUTILEX_GETCODEMEMORY           0x0000001A
#define DISPID_SIUTILEX_SETRAMMEMORY            0x0000001B
#define DISPID_SIUTILEX_SETXRAMMEMORY           0x0000001C
#define DISPID_SIUTILEX_SETCODEMEMORY           0x0000001D
#define DISPID_SIUTILEX_FLASHERASE              0x0000001E
#define DISPID_SIUTILEX_GETSAFIRMWAREVERSION    0x0000001F
#define DISPID_SIUTILEX_SETJTAGDEVICEANDCONNECT 0x00000020
#define DISPID_SIUTILEX_GETDEVICENAME           0x00000023
#define DISPID_SIUTILEX_SETAPPNAME              0x00000024
#define DISPID_SIUTILEX_GETSCRATCHPADMEMORY     0x00000025
#define DISPID_SIUTILEX_SETSCRATCHPADMEMORY     0x00000026
#define DISPID_SIUTILEX_VERIFYFLASHDOWNLOAD     0x00000027
#define DISPID_SIUTILEX_DOWNLOADTXT             0x00000028
#define DISPID_SIUTILEX_GETDEVICEREVISION       0x00000029

#define DISPID_SIUTILEX_SERIALNUMBER            0x00000001
#define DISPID_SIUTILEX_GETFIRMWAREVERSION      0x0000001F
#define DISPID_SIUTILEX_DEBUGDEVICES            0x00000021
#define DISPID_SIUTILEX_GETDEVICESN             0x00000022

#endif
