#ifndef MISC_H
#define MISC_H

typedef HRESULT (__stdcall * GETSETMEMORYFUNCTION)(BYTE* ptrMem, DWORD wStartAddress, unsigned int nLength);
HRESULT GetMemory(GETSETMEMORYFUNCTION pfn, long nStartAddress, long nLength, SAFEARRAY** ppMem);
HRESULT SetMemory(GETSETMEMORYFUNCTION pfn, BOOL blDisableDialogBoxes, long nStartAddress, SAFEARRAY** ppMem);
HRESULT DownloadW(PCWSTR sDownloadFile, VARIANT_BOOL blDeviceErase, BOOL blDisableDialogBoxes, VARIANT_BOOL nDownloadScratchPadSFLE, long nBankSelect, VARIANT_BOOL nLockFlash, VARIANT_BOOL blPersistFlash, long* usChecksum);
HRESULT DownloadTxtW(PCWSTR sDownloadFile, long wStartAddress, VARIANT_BOOL blDeviceErase, BOOL blDisableDialogBoxes, VARIANT_BOOL blLockFlash, VARIANT_BOOL blPersistFlash, long* usChecksum);
HRESULT SetAppNameW(LPCWSTR AppName);
HRESULT VerifyFlashDownloadW(PCWSTR sDownloadFile, BOOL blDisableDialogBoxes, long nBankSelect, VARIANT_BOOL* vblSuccess);

HRESULT BSTRFromStringA(const char* pstr, BSTR* pbstr);

template<typename T> FORCEINLINE BOOL IsBadWritePtrT(T* lp)
{
#ifdef _DEBUG
    return(::IsBadWritePtr(lp, sizeof(*lp)));
#else
    return(!lp);
#endif
}

template<typename T> FORCEINLINE BOOL IsBadReadPtrT(const T* lp)
{
#ifdef _DEBUG
    return(::IsBadReadPtr(lp, sizeof(*lp)));
#else
    return(!lp);
#endif
}

// combaseapi.h defines STDMETHOD together with COM_DECLSPEC_NOTHROW,
// whereas STDMETHODIMP (winnt.h) got defined without it, hence you'll
// get a ton of C4986 when compiling with /Wall. The definitions below
// address this issue.
#undef STDMETHODIMP
#define STDMETHODIMP            COM_DECLSPEC_NOTHROW HRESULT STDMETHODCALLTYPE
#undef STDMETHODIMP_
#define STDMETHODIMP_(type)     COM_DECLSPEC_NOTHROW type STDMETHODCALLTYPE
#undef IFACEMETHODIMP
#define IFACEMETHODIMP          __override STDMETHODIMP
#undef IFACEMETHODIMP_
#define IFACEMETHODIMP_(type)   __override STDMETHODIMP_(type)

#endif
